#define _CRT_SECURE_NO_DEPRECATE 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <windows.h>

#include "resource.h"
#include "audioeffectx.h"
#include "vstcontrols.h"


// ============================================================================================
// ݌v̋L
// ============================================================================================
#define MY_VST_VENDOR       "test vendor"        //(x_[)
#define MY_VST_VERSION      1                    //VSTo[W
#define MY_VST_PRODUCT_NAME "Sample VST GUI"   //VST̐i
#define MY_VST_NAME         "GUI"              //VST̖O

#define MY_VST_INPUT_NUM   2 //͐Bm=1AXeI=2
#define MY_VST_OUTPUT_NUM  2 //o͐Bmo=1AXeIo=2

#define MY_VST_UNIQUE_ID  'SMPL' //j[NID
                                 //Jꍇ͈ȉURLŔsꂽj[NID͂B
                                 //http://ygrabit.steinberg.de/~ygrabit/public_html/index.html

#define MY_VST_PRESET_NUM    1 //vZbgvO̐
#define MY_VST_PARAMETER_NUM 2 //p[^̐

#define MYVST_VOLUME_L 0
#define MYVST_VOLUME_R 1
// ============================================================================================
// VST GUINX
// ============================================================================================
class VstGui2 : public AEffGUIEditor, CControlListener
{
public:
	VstGui2 (void* effect);
	virtual ~VstGui2 ();

	// GUIWindowJƂƕƂɏs֐
	virtual bool open (void *ptr);
	virtual void close ();

	// {^܂ݓꂽƂɏs֐
	virtual void valueChanged (CDrawContext *pContext, CControl *pControl);
	virtual void setParameter (VstInt32 index, float value);

protected:
	// {[𑀍삷܂
	CKnob*   knobVolumeL;
	CKnob*   knobVolumeR;
};

VstGui2::VstGui2 (void* effect)
: AEffGUIEditor ((AudioEffect*)effect)
{
	// p̂ɂrectϐB
	// rectϐGUIWindowsTCYݒ肷B
	// (ݒsȂWindowJȂ)
	rect.left   = 0;
	rect.top    = 0;
	rect.right  = 512;
	rect.bottom = 256;

	// VstGui2NXŗL̏s
	knobVolumeL = 0;
	knobVolumeR = 0;
}

VstGui2::~VstGui2 ()
{
}

void VstGui2::valueChanged (CDrawContext *pContext, CControl *pControl)
{
	// ǂ̃p[^[삳ꂽ擾B
	VstInt32 index = pControl->getTag();

	// p[^[̒l擾B
	float value = pControl->getValue ();

	// 擾lp[^[ɔf
	this->setParameter(index, value);
}

void VstGui2::setParameter (VstInt32 index, float value)
{
	switch (index)
	{
	case MYVST_VOLUME_L:
		// ܂݂ɒlݒ肵AʂXV(`悳B)
		knobVolumeL->setValue (value);

		// MyVstGui2(AudioEffectXpčNX)
		// 삳ꂽp[^[ʒmčXV
		// (setParameterAutomated͓setParameterĂяo)
		effect->setParameterAutomated(index, value);
		break;

	case MYVST_VOLUME_R:
		// MYVST_VOLUME_L̏Ƃقړl
		knobVolumeR->setValue (value);
		effect->setParameterAutomated(index, value);
		break;

	default:
		break;
	}
}

bool VstGui2::open (void *ptr)
{
	// ܂͌p̊֐Ăяo(K{)
	AEffGUIEditor::open (ptr);

	// Ƀt[(CFrame)쐬B
	// {^܂ݓ͂̃t[̏ɔzu`ɂȂ
	// łWindowƓTCỸt[쐬Ă
	CRect size (rect.left, rect.top, rect.right, rect.bottom);

	CFrame* cframe = new CFrame (size, ptr, this);
	// 쐬t[͌pɂframeϐɒlۑKvB
	this->frame = cframe;

	// -----------------------------------------------------------------
	// ܂݂쐬B
	// ܂ݗp̉摜\[Xǂݍ
	CBitmap *KnobBack   = new CBitmap (BITMAP_KNOB_BACK);
	CBitmap *KnobHandle = new CBitmap (BITMAP_KNOB_HANDLE);

	// ܂݂̑傫ݒ
 	CRect knobsize (0, 0, KnobBack->getWidth (), KnobBack->getHeight ());

	// ܂݂̈ʒuݒ
	knobsize.offset (16, 16);

	// ܂݉摜ǂ\邩̐ݒB{I0, 0ł悢͂B
	CPoint point (0, 0);

	knobVolumeL = new CKnob (knobsize, this, MYVST_VOLUME_L, KnobBack, KnobHandle, point);
	// ܂݂̒Sƃnh܂ł̒
	knobVolumeL->setInsetValue (7);
	// ݂̃{[MyVstGui2(AudioEffectXpčNX)擾
	knobVolumeL->setValue(effect->getParameter(MYVST_VOLUME_L));
	// ܂݂frameɒǉ
	frame->addView (knobVolumeL);

	// knobVolumeLƂقړl
	knobsize (0, 0, KnobBack->getWidth (), KnobBack->getHeight ());
	knobsize.offset (64, 16);
	knobVolumeR = new CKnob (knobsize, this, MYVST_VOLUME_R, KnobBack, KnobHandle, point);
	knobVolumeR->setInsetValue (7);
	knobVolumeR->setValue(effect->getParameter(MYVST_VOLUME_R));
	frame->addView (knobVolumeR);

	// ܂ݗp̉摜
	KnobBack->forget();
	KnobHandle->forget();

	// ɖ肪ȂtrueԂ
	return true;
}

void VstGui2::close ()
{
	// framedelete邱ƂYȂ悤ɂ
	if (frame)
	{
		delete frame;
	}
	frame = 0;
}

// ============================================================================================
// VST̊{ƂȂNX
// ============================================================================================
class MyVstGui2 : public AudioEffectX
{
public:
	MyVstGui2 (audioMasterCallback audioMaster);
	~MyVstGui2 ();

	// GtFN^[̃p[^Ɋւ郁o[֐
	virtual void  setParameter (VstInt32 index, float value);

	// M郁o[֐
	virtual void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames);

protected:
	float volumeL;
	float volumeR;
};

// ============================================================================================
// VST̂𐶐邽߂̊֐
// ============================================================================================
AudioEffect* createEffectInstance (audioMasterCallback audioMaster)
{
	//newłVST𐶐|C^Ԃ
	return new MyVstGui2 (audioMaster);
}

// ============================================================================================
// RXgN^AfXgN^(VST̏AILq)
// ============================================================================================
MyVstGui2::MyVstGui2 (audioMasterCallback audioMaster)
: AudioEffectX (audioMaster, MY_VST_PRESET_NUM, MY_VST_PARAMETER_NUM)
{
	//VST̏sB

	//ȉ̊֐Ăяoē͐Ao͐̏ݒ肷B
	//KĂяoȂ΂ȂȂB
	setNumInputs (MY_VST_INPUT_NUM);    //͐̐ݒ
	setNumOutputs (MY_VST_OUTPUT_NUM);  //o͐̐ݒ
	setUniqueID (MY_VST_UNIQUE_ID);     //j[NID̐ݒ

	isSynth (false);          //VSTSynthǂ̃tOݒB
	                         //Synth̏ꍇctrueAEffectoȑꍇcfalse

	canProcessReplacing ();  //VST\ǂ̃tOݒB
	                         //sȂVST͂Ȃ̂ŕK̊֐ĂяoB

	// GUIݒ肷
	editor = new VstGui2(this);

	//VST̃p[^B
	volumeL = 0.0f;
	volumeR = 0.0f;
}

MyVstGui2::~MyVstGui2 ()
{
	//VST̏IB
	//VSTł͓Ɏs鏈͂ȂB

	// GUIdeleteȂĂۂ
}

void MyVstGui2::setParameter (VstInt32 index, float value)
{
	switch (index)
	{
	case MYVST_VOLUME_L:
		volumeL = value;
		break;

	case MYVST_VOLUME_R:
		volumeR = value;
		break;

	default:
		break;
	}
}

// ============================================================================================
// M郁o[֐
// ============================================================================================
void MyVstGui2::processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames)
{
	float *inL = inputs[0]; // p
	float *inR = inputs[1]; // Ep
	float *outL = outputs[0]; //o p
	float *outR = outputs[1]; //o Ep

	for (int i = 0; i <sampleFrames ; i++)
	{
		// ͂̂܂܏o͂
		outL[i] = volumeL * inL[i];
		outR[i] = volumeR * inR[i];
	}
}

